<?php

namespace Schaffen\Gef\Criterias;

use Prettus\Repository\Contracts\RepositoryInterface;
use Prettus\Repository\Contracts\CriteriaInterface;
use Carbon\Carbon;


class AgendamentosDentroPeriodoCriteria implements CriteriaInterface
{

   private $motorista;
   private $veiculo;
   private $data_inicial;
   private $data_final;

   public function __construct($motorista, $veiculo, $data_inicial, $data_final)
   {
      $this->motorista = $motorista;
      $this->veiculo = $veiculo;
      $this->data_inicial = $data_inicial;
      $this->data_final =  $data_final;
   }

   public function apply($model, RepositoryInterface $repository)
   {
      $model = $model->where('agu_fk_motorista_pes_codigo', $this->motorista)
                     ->where('agu_fk_vei_codigo', $this->veiculo)
                     ->where('agu_data_disponibilidade_inicial','<=', $this->data_inicial->format('Y-m-d'))
                     ->where('agu_data_disponibilidade_final','>=', $this->data_final->format('Y-m-d'));
      return $model;
   }
}